glibmm: Gio::DataInputStream Class Reference

glibmm 2.29.13

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions

# Gio::DataInputStream Class Reference
Stream Classes

An implementation of BufferedInputStream that allows for high-level data manipulation of arbitrary data (including binary operations). More...

`#include <giomm/datainputstream.h>`

Inheritance diagram for Gio::DataInputStream:
[legend]

List of all members.

## Public Member Functions
virtual | ~DataInputStream ()
GDataInputStream* | gobj ()
| Provides access to the underlying C GObject.
const GDataInputStream* | gobj () const
| Provides access to the underlying C GObject.
GDataInputStream* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
void | set_byte_order (DataStreamByteOrder order)
| This function sets the byte order for the given stream.
DataStreamByteOrder | get_byte_order () const
| Gets the byte order for the data input stream.
void | set_newline_type (DataStreamNewlineType type)
| Sets the newline type for the stream.
DataStreamNewlineType | get_newline_type () const
| Gets the current newline type for the stream.
guchar | read_byte (const Glib::RefPtr< Cancellable >& cancellable)
| Reads an unsigned 8-bit/1-byte value from stream.
guchar | read_byte ()
| non-cancellable version of read_byte()
gint16 | read_int16 (const Glib::RefPtr< Cancellable >& cancellable)
| Reads a 16-bit/2-byte value from stream.
gint16 | read_int16 ()
| non-cancellable version of read_int16()
guint16 | read_uint16 (const Glib::RefPtr< Cancellable >& cancellable)
| Reads an unsigned 16-bit/2-byte value from stream.
guint16 | read_uint16 ()
| non-cancellable version of read_uint16()
gint32 | read_int32 (const Glib::RefPtr< Cancellable >& cancellable)
| Reads a signed 32-bit/4-byte value from stream.
gint32 | read_int32 ()
| non-cancellable version of read_int32()
guint32 | read_uint32 (const Glib::RefPtr< Cancellable >& cancellable)
| Reads an unsigned 32-bit/4-byte value from stream.
guint32 | read_uint32 ()
| non-cancellable version of read_uint32()
gint64 | read_int64 (const Glib::RefPtr< Cancellable >& cancellable)
| Reads a 64-bit/8-byte value from stream.
gint64 | read_int64 ()
| non-cancellable version of read_int64()
guint64 | read_uint64 (const Glib::RefPtr< Cancellable >& cancellable)
| Reads an unsigned 64-bit/8-byte value from stream.
guint64 | read_uint64 ()
| non-cancellable version of read_uint64()
bool | read_line (std::string& line, const Glib::RefPtr< Cancellable >& cancellable)
| Reads a line from the data input stream.
bool | read_line (std::string& line)
| A non-cancellable version of read_line().
void | read_line_async (const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| The asynchronous version of read_until().
bool | read_line_finish (const Glib::RefPtr< AsyncResult >& result, std::string& data)
| Finish an asynchronous call started by read_line_async().
bool | read_until (std::string& data, const std::string& stop_chars, const Glib::RefPtr< Cancellable >& cancellable)
| Reads a string from the data input stream, up to the first occurrence of any of the stop characters.
bool | read_until (std::string& data, const std::string& stop_chars)
| A non-cancellable version of read_until().
void | read_until_async (const std::string& stop_chars, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| The asynchronous version of read_until().
bool | read_until_finish (const Glib::RefPtr< AsyncResult >& result, std::string& data)
| Finish an asynchronous call started by read_until_async().
bool | read_upto (std::string& data, const std::string& stop_chars, const Glib::RefPtr< Cancellable >& cancellable)
| Reads a string from the data input stream, up to the first occurrence of any of the stop characters.
bool | read_upto (std::string& data, const std::string& stop_chars)
| A non-cancellable version of read_upto().
void | read_upto_async (const std::string& stop_chars, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| The asynchronous version of read_upto().
bool | read_upto_finish (const Glib::RefPtr< AsyncResult >& result, std::string& data)
| Finish an asynchronous call started by read_upto_async().
Glib::PropertyProxy < DataStreamByteOrder > | property_byte_order ()
| The byte order.
Glib::PropertyProxy_ReadOnly < DataStreamByteOrder > | property_byte_order () const
| The byte order.
Glib::PropertyProxy < DataStreamNewlineType > | property_newline_type ()
| The accepted types of line ending.
Glib::PropertyProxy_ReadOnly < DataStreamNewlineType > | property_newline_type () const
| The accepted types of line ending.
## Static Public Member Functions
static Glib::RefPtr < DataInputStream > | create (const Glib::RefPtr< InputStream >& base_stream)
| Creates a new InputStream from the given base_stream, with a buffer set to the default size (4 kilobytes).
## Protected Member Functions
| DataInputStream (const Glib::RefPtr< InputStream >& base_stream)
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr < Gio::DataInputStream > | wrap (GDataInputStream* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

An implementation of BufferedInputStream that allows for high-level data manipulation of arbitrary data (including binary operations).

Since glibmm 2.16:

## Constructor & Destructor Documentation

virtual Gio::DataInputStream::~DataInputStream | ( |  | ) | `[virtual]`

Gio::DataInputStream::DataInputStream | ( | const Glib::RefPtr< InputStream >& | base_stream | ) | `[explicit, protected]`

## Member Function Documentation

static Glib::RefPtr<DataInputStream> Gio::DataInputStream::create | ( | const Glib::RefPtr< InputStream >& | base_stream | ) | `[static]`

Creates a new InputStream from the given base_stream, with a buffer set to the default size (4 kilobytes).

Parameters:

  base_stream | An InputStream.

Returns:
  an InputStream for the given base_stream.

Reimplemented from Gio::BufferedInputStream.

DataStreamByteOrder Gio::DataInputStream::get_byte_order | ( |  | ) | const

Gets the byte order for the data input stream.

Returns:
  The stream's current DataStreamByteOrder.

DataStreamNewlineType Gio::DataInputStream::get_newline_type | ( |  | ) | const

Gets the current newline type for the stream.

Returns:
  DataStreamNewlineType for the given stream.

GDataInputStream* Gio::DataInputStream::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Gio::BufferedInputStream.

const GDataInputStream* Gio::DataInputStream::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Gio::BufferedInputStream.

GDataInputStream* Gio::DataInputStream::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Reimplemented from Gio::BufferedInputStream.

Glib::PropertyProxy<DataStreamByteOrder> Gio::DataInputStream::property_byte_order | ( |  | ) |

The byte order.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<DataStreamByteOrder> Gio::DataInputStream::property_byte_order | ( |  | ) | const

The byte order.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<DataStreamNewlineType> Gio::DataInputStream::property_newline_type | ( |  | ) |

The accepted types of line ending.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<DataStreamNewlineType> Gio::DataInputStream::property_newline_type | ( |  | ) | const

The accepted types of line ending.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

guchar Gio::DataInputStream::read_byte | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Reads an unsigned 8-bit/1-byte value from stream.

Parameters:

  cancellable | Optional Cancellable object, `0` to ignore.

Returns:
  An unsigned 8-bit/1-byte value read from the stream or 0 if an error occurred.

Reimplemented from Gio::BufferedInputStream.

guchar Gio::DataInputStream::read_byte | ( |  | ) |

non-cancellable version of read_byte()

Reimplemented from Gio::BufferedInputStream.

gint16 Gio::DataInputStream::read_int16 | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Reads a 16-bit/2-byte value from stream.

In order to get the correct byte order for this read operation, see g_data_input_stream_get_byte_order() and g_data_input_stream_set_byte_order().

Parameters:

  cancellable | Optional Cancellable object, `0` to ignore.

Returns:
  A signed 16-bit/2-byte value read from stream or 0 if an error occurred.

gint16 Gio::DataInputStream::read_int16 | ( |  | ) |

non-cancellable version of read_int16()

gint32 Gio::DataInputStream::read_int32 | ( |  | ) |

non-cancellable version of read_int32()

gint32 Gio::DataInputStream::read_int32 | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Reads a signed 32-bit/4-byte value from stream.

In order to get the correct byte order for this read operation, see Glib::data_stream_get_byte_order() and Glib::data_stream_set_byte_order().

The operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, a Gio::Error will be thrown with CANCELLED.

Parameters:

  cancellable | Cancellable object.

Returns:
  A signed 32-bit/4-byte value read from the stream or 0 if an error occurred.

gint64 Gio::DataInputStream::read_int64 | ( |  | ) |

non-cancellable version of read_int64()

gint64 Gio::DataInputStream::read_int64 | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Reads a 64-bit/8-byte value from stream.

In order to get the correct byte order for this read operation, see Glib::data_stream_get_byte_order() and Glib::data_stream_set_byte_order().

The operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, a Gio::Error will be thrown with CANCELLED.

Parameters:

  cancellable | Cancellable object.

Returns:
  A signed 64-bit/8-byte value read from stream or 0 if an error occurred.

bool Gio::DataInputStream::read_line | ( | std::string & | line,
|  | const Glib::RefPtr< Cancellable >& | cancellable
| ) |  |

Reads a line from the data input stream.

The operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, a Gio::Error with CANCELLED will be thrown.

Parameters:

  data | A string to fill with the read data (without the newlines).
  cancellable | A cancellable object.

Returns:
  true if the read succeeded without error.

bool Gio::DataInputStream::read_line | ( | std::string & | line | ) |

A non-cancellable version of read_line().

Parameters:

  data | A string to fill with the read data (without the newlines).

Returns:
  true if the read succeeded without error.

void Gio::DataInputStream::read_line_async | ( | const SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Cancellable >& | cancellable,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |

The asynchronous version of read_until().

It is an error to have two outstanding calls to this function.

Parameters:

  slot | The slot to call when the request is satisfied.
  cancellable | A cancellable object.
  io_priority | The I/O priority of the request.

Returns:
  true if the read succeeded without error.

bool Gio::DataInputStream::read_line_finish | ( | const Glib::RefPtr< AsyncResult >& | result,
|  | std::string & | data
| ) |  |

Finish an asynchronous call started by read_line_async().

Parameters:

  result | The AsyncResult that was provided to the callback slot.
  data | A string to fill with the read data.

Returns:
  true if the read succeeded without error.

guint16 Gio::DataInputStream::read_uint16 | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Reads an unsigned 16-bit/2-byte value from stream.

In order to get the correct byte order for this read operation, see g_data_input_stream_get_byte_order() and g_data_input_stream_set_byte_order().

Parameters:

  cancellable | Optional Cancellable object, `0` to ignore.

Returns:
  An unsigned 16-bit/2-byte value read from the stream or 0 if an error occurred.

guint16 Gio::DataInputStream::read_uint16 | ( |  | ) |

non-cancellable version of read_uint16()

guint32 Gio::DataInputStream::read_uint32 | ( |  | ) |

non-cancellable version of read_uint32()

guint32 Gio::DataInputStream::read_uint32 | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Reads an unsigned 32-bit/4-byte value from stream.

In order to get the correct byte order for this read operation, see Glib::data_stream_get_byte_order() and Glib::data_stream_set_byte_order().

The operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, a Gio::Error will be thrown with CANCELLED.

Parameters:

  cancellable | Cancellable object.

Returns:
  An unsigned 32-bit/4-byte value read from the stream or 0 if an error occurred.

guint64 Gio::DataInputStream::read_uint64 | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Reads an unsigned 64-bit/8-byte value from stream.

In order to get the correct byte order for this read operation, see Glib::data_stream_get_byte_order().

The operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, a Gio::Error will be thrown with CANCELLED.

Parameters:

  cancellable | Cancellable object.

Returns:
  An unsigned 64-bit/8-byte read from stream or 0 if an error occurred.

guint64 Gio::DataInputStream::read_uint64 | ( |  | ) |

non-cancellable version of read_uint64()

bool Gio::DataInputStream::read_until | ( | std::string & | data,
|  | const std::string & | stop_chars,
|  | const Glib::RefPtr< Cancellable >& | cancellable
| ) |  |

Reads a string from the data input stream, up to the first occurrence of any of the stop characters.

Note that, in contrast to read_until_async(), this function consumes the stop character that it finds.

Don't use this function in new code. Its functionality is inconsistent with read_until_async(). Both functions will be marked as deprecated in a future release. Use read_upto() instead, but note that that method does not consume the stop character.

Parameters:

  data | A string to fill with the read data.
  stop_chars | Characters to terminate the read.
  cancellable | A cancellable object.

Returns:
  true if the read succeeded without error.

bool Gio::DataInputStream::read_until | ( | std::string & | data,
|  | const std::string & | stop_chars
| ) |  |

A non-cancellable version of read_until().

Note that, in contrast to read_until_async(), this function consumes the stop character that it finds.

Don't use this function in new code. Its functionality is inconsistent with read_until_async(). Both functions will be marked as deprecated in a future release. Use read_upto() instead, but note that that method does not consume the stop character.

Parameters:

  stop_chars | Characters to terminate the read.
  data | A string to fill with the read data.

Returns:
  true if the read succeeded without error.

void Gio::DataInputStream::read_until_async | ( | const std::string & | stop_chars,
|  | const SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Cancellable >& | cancellable,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |

The asynchronous version of read_until().

It is an error to have two outstanding calls to this function.

Note that, in contrast to ead_until(), this function does not consume the stop character that it finds. You must read it for yourself.

Don't use this function in new code. Its functionality is inconsistent with read_until(). Both functions will be marked as deprecated in a future release. Use read_upto_async() instead.

Parameters:

  stop_chars | Characters to terminate the read.
  slot | The slot to call when the request is satisfied.
  cancellable | A cancellable object.
  io_priority | The I/O priority of the request.

Returns:
  true if the read succeeded without error.

bool Gio::DataInputStream::read_until_finish | ( | const Glib::RefPtr< AsyncResult >& | result,
|  | std::string & | data
| ) |  |

Finish an asynchronous call started by read_until_async().

Parameters:

  result | The AsyncResult that was provided to the callback slot.
  data | A string to fill with the read data.

Returns:
  true if the read succeeded without error.

bool Gio::DataInputStream::read_upto | ( | std::string & | data,
|  | const std::string & | stop_chars
| ) |  |

A non-cancellable version of read_upto().

Parameters:

  stop_chars | Characters to terminate the read.
  data | A string to fill with the read data.

Returns:
  true if the read succeeded without error.

bool Gio::DataInputStream::read_upto | ( | std::string & | data,
|  | const std::string & | stop_chars,
|  | const Glib::RefPtr< Cancellable >& | cancellable
| ) |  |

Reads a string from the data input stream, up to the first occurrence of any of the stop characters.

In contrast to read_until(), this method does <emphasis>not</emphasis> consume the stop character. You have to use read_byte() to get it before calling read_upto() again.

Parameters:

  data | A string to fill with the read data.
  stop_chars | Characters to terminate the read.
  cancellable | A cancellable object.

Returns:
  true if the read succeeded without error.

void Gio::DataInputStream::read_upto_async | ( | const std::string & | stop_chars,
|  | const SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Cancellable >& | cancellable,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |

The asynchronous version of read_upto().

It is an error to have two outstanding calls to this function.

In contrast to read_until(), this method does <emphasis>not</emphasis> consume the stop character. You have to use read_byte() to get it before calling read_upto() again.

Parameters:

  stop_chars | Characters to terminate the read.
  slot | The slot to call when the request is satisfied.
  cancellable | A cancellable object.
  io_priority | The I/O priority of the request.

Returns:
  true if the read succeeded without error.

bool Gio::DataInputStream::read_upto_finish | ( | const Glib::RefPtr< AsyncResult >& | result,
|  | std::string & | data
| ) |  |

Finish an asynchronous call started by read_upto_async().

Note that this function does <emphasis>not</emphasis> consume the stop character. You have to use read_byte() to get it before calling read_upto_async() again.

Parameters:

  result | The AsyncResult that was provided to the callback slot.
  data | A string to fill with the read data.

Returns:
  true if the read succeeded without error.

void Gio::DataInputStream::set_byte_order | ( | DataStreamByteOrder | order | ) |

This function sets the byte order for the given stream.

All subsequent reads from the stream will be read in the given order.

Parameters:

  order | A DataStreamByteOrder to set.

void Gio::DataInputStream::set_newline_type | ( | DataStreamNewlineType | type | ) |

Sets the newline type for the stream.

Note that using G_DATA_STREAM_NEWLINE_TYPE_ANY is slightly unsafe. If a read chunk ends in "CR" we must read an additional byte to know if this is "CR" or "CR LF", and this might block if there is no more data availible.

Parameters:

  type | The type of new line return as DataStreamNewlineType.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::DataInputStream > wrap | ( | GDataInputStream * | object,
|  | bool | take_copy = `false`
| ) |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.